#include <emscripten.h>
#include <emscripten/bind.h>
#include <iostream>

using namespace emscripten;

class Person {
public:
  Person(std::string name, int age) : name(name), age(age) {}

  void plusAge() { ++age; }

  int getAge() const { return age; }

  void setAge(int age_) { age = age_; }

  void toString() {
    std::cout << "(name=" << name << ", age=" << age << ")" << std::endl;
  }

  static std::string getStringFromInstance(const Person &instance) {
    return instance.name;
  }

private:
  int age;
  std::string name;
};

// Binding code
EMSCRIPTEN_BINDINGS(person) {
  class_<Person>("Person")
      .constructor<std::string, int>()
      .function("plusAge", &Person::plusAge)
      .function("toString", &Person::toString)
      .property("age", &Person::getAge, &Person::setAge)
      .class_function("getStringFromInstance", &Person::getStringFromInstance);
}